import { useStore } from 'jotai/react';
import { createStore, Atom } from 'jotai/vanilla';
import { INTERNAL_DevStoreRev4, INTERNAL_PrdStore } from 'jotai/vanilla/store2';

type StoreV1 = ReturnType<typeof createStore>;
type StoreV2 = INTERNAL_DevStoreRev4 & INTERNAL_PrdStore;
type Store = StoreV1 | StoreV2;
type Options = Parameters<typeof useStore>[0];
type AnyAtomValue = unknown;
type AnyAtom = Atom<AnyAtomValue>;
type AtomsValues = Map<AnyAtom, AnyAtomValue>;
type AtomsDependents = Map<AnyAtom, Set<AnyAtom>>;
type AtomsSnapshot = Readonly<{
    values: AtomsValues;
    dependents: AtomsDependents;
}>;

export type { AtomsSnapshot as A, Options as O, Store as S };
